/*
 * Copyright (c) 2005 Dmirty Alexandrov aka dimzon aka dimzon541 (dimzon541@gmail.com)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#include "stdafx.h"
#include "bse.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

HANDLE g_hStream = NULL;
PROCESS_INFORMATION g_ProcessInformation;

void About(char* s)
{
	sprintf(s, "bsn.dll replacement by Dimzon & Kurtnoise, Build %s, %s", __DATE__, __TIME__);
}



char * my_strcat(char* a, const char* b)
{
	return a+sprintf(a,"%s%s", a, b);
}

int Init222(
		 int nSampleRate,
		 int nChannelsCount,
		 int nBitsPerSample,
		 char * sOutFileName,
		 char** argv,int argc,
		 char * sDescription,
		 char * err
		 )
{
	char * exeName1 = "neroAacEnc.exe"; // default executable
	char argumentLine[4096];
	memset(argumentLine,0,sizeof(argumentLine));
	char * p = argumentLine;

//	p = my_strcat(p, "-ignorelength");

	for(int i=0;i<argc;i++)
	{
		// Detecting executable name
		if(0==strcmp(argv[i],"-exe"))
		{
			exeName1 = argv[++i];
			continue;
		}

		/* Nero CLI Commands */
		if(0==strcmp(argv[i],"-cbr"))
		{
			p += sprintf(p," -cbr %s000", argv[++i]); 
			continue;
		}
		if(0==strcmp(argv[i],"-abr"))
		{
			p += sprintf(p," -br %s000", argv[++i]); 
			continue;
		}
		if (strcmp(argv[i], "-vbr_tape") == 0) 
		{
			p=my_strcat(p, " -q 0.1");
			continue;
		}
		if (strcmp(argv[i], "-vbr_radio") == 0) 
		{
			p=my_strcat(p, " -q 0.2");
			continue;
		}
		if (strcmp(argv[i], "-vbr_internet") == 0) 
		{
			p=my_strcat(p, " -q 0.3");
			continue;
		}
		if (strcmp(argv[i], "-vbr_streaming") == 0) 
		{
			p=my_strcat(p, " -q 0.4");
			continue;
		}
		if (strcmp(argv[i], "-vbr_normal") == 0) 
		{
			p=my_strcat(p, " -q 0.5");
			continue;
		}
		if (strcmp(argv[i], "-vbr_extreme") == 0) 
		{
			p=my_strcat(p, " -q 0.6");
			continue;
		}
		if (strcmp(argv[i], "-vbr_audiophile") == 0) 
		{
			p=my_strcat(p, " -q 0.7");
			continue;
		}
		if (strcmp(argv[i], "-vbr_transcoding") == 0) 
		{
			p=my_strcat(p, " -q 0.8");
			continue;
		}
		if(0==strcmp(argv[i],"-vbr"))
		{
			p += sprintf(p," -q %s", argv[++i]); 
			continue;
		}
		if (strcmp(argv[i], "-hintforstreaming") == 0) 
		{
			p=my_strcat(p, " -hinttrack");
			continue;
		}
		if (strcmp(argv[i], "-aacprofile_lc") == 0)
		{
			p=my_strcat(p, " -lc");
			continue;
		}
		if (strcmp(argv[i], "-aacprofile_he") == 0)
		{
			p=my_strcat(p, " -he");
			continue;
		}
		if (strcmp(argv[i], "-aacprofile_hev2") == 0)
		{
			p=my_strcat(p, " -hev2");
			continue;
		}

		/* Aften Commands */
		if(0==strcmp(argv[i],"-b"))
		{
			p += sprintf(p," -b %s", argv[++i]); 
			continue;
		}
		if(0==strcmp(argv[i],"-q"))
		{
			p += sprintf(p," -q %s", argv[++i]); 
			continue;
		}
		if(0==strcmp(argv[i], "-fba"))
		{
			p += sprintf(p," -fba %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-w"))
		{
			p += sprintf(p," -w %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-m"))
		{
			p += sprintf(p," -m %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-s"))
		{
			p += sprintf(p," -s %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-cmix"))
		{
			p += sprintf(p," -cmix %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-smix"))
		{
			p += sprintf(p," -smix %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-dsur"))
		{
			p += sprintf(p," -dsur %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-dnorm"))
		{
			p += sprintf(p," -dnorm %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-acmod"))
		{
			p += sprintf(p," -acmod %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-lfe"))
		{
			p += sprintf(p," -lfe %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-bwfilter"))
		{
			p += sprintf(p," -bwfilter %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-dcfilter"))
		{
			p += sprintf(p," -dcfilter %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-lfefilter"))
		{
			p += sprintf(p," -lfefilter %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-xbsi1"))
		{
			p += sprintf(p," -xbsi1 %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-dmixmod"))
		{
			p += sprintf(p," -dmixmod %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-ltrtcmix"))
		{
			p += sprintf(p," -ltrtcmix %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-ltrtsmix"))
		{
			p += sprintf(p," -ltrtsmix %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-lorocmix"))
		{
			p += sprintf(p," -lorocmix %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-lorosmix"))
		{
			p += sprintf(p," -lorosmix %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-xbsi2"))
		{
			p += sprintf(p," -xbsi2 %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-dsurexmod"))
		{
			p += sprintf(p," -dsurexmod %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-dheadphon"))
		{
			p += sprintf(p," -dheadphon %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-adconvtyp"))
		{
			p += sprintf(p," -adconvtyp %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "-readtoeof"))
		{
			p += sprintf(p," -readtoeof %s", argv[++i]);
			continue;
		}

		/* Flake */
		if(0==strcmp(argv[i], "-level"))
		{
			p += sprintf(p," -%s", argv[++i]);
			continue;
		}
		
		/* FAAC */
		if(0==strcmp(argv[i], "-c"))
		{
			p += sprintf(p," -c %s", argv[++i]);
			continue;
		}
		if (strcmp(argv[i], "-mp4") == 0)
		{
			p=my_strcat(p, " -w");
			continue;
		}
		if (strcmp(argv[i], "--tns") == 0)
		{
			p=my_strcat(p, " --tns");
			continue;
		}
		if(0==strcmp(argv[i], "--object-type"))
		{
			p += sprintf(p," --object-type %s", argv[++i]);
			continue;
		}
		if (strcmp(argv[i], "--no-midside") == 0)
		{
			p=my_strcat(p, " --no-midside");
			continue;
		}
		if(0==strcmp(argv[i], "--mpeg-vers"))
		{
			p += sprintf(p," --mpeg-vers %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "--shortctl"))
		{
			p += sprintf(p," --shortctl %s", argv[++i]);
			continue;
		}

		/* Speex */
		if(0==strcmp(argv[i], "--quality"))
		{
			p += sprintf(p," --quality %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "--abr"))
		{
			p += sprintf(p," --abr %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "--bitrate"))
		{
			p += sprintf(p," --bitrate %s", argv[++i]);
			continue;
		}
		if (strcmp(argv[i], "--vbr") == 0)
		{
			p=my_strcat(p, " --vbr");
			continue;
		}
		if (strcmp(argv[i], "--agc") == 0)
		{
			p=my_strcat(p, " --agc");
			continue;
		}
		if (strcmp(argv[i], "--denoise") == 0)
		{
			p=my_strcat(p, " --denoise");
			continue;
		}
		if(0==strcmp(argv[i], "--comp"))
		{
			p += sprintf(p," --comp %s", argv[++i]);
			continue;
		}
		if(0==strcmp(argv[i], "--nframes"))
		{
			p += sprintf(p," --nframes %s", argv[++i]);
			continue;
		}

		/* 3GPP Reference Encoder  */
		if (strcmp(argv[i], "-mono") == 0)
		{
			p=my_strcat(p, " -mono");
			continue;
		}
		if (strcmp(argv[i], "-nops") == 0)
		{
			p=my_strcat(p, " -nops");
			continue;
		}

		/* FraunHofer mp3 surround Encoder */ 
		if(exeName1 == "mp3sEncoder.exe")
		{
			p=my_strcat(p, (" -eof -if - -of \"%s\"", sOutFileName));
		if(0==strcmp(argv[i],"-br"))
			{
				p += sprintf(p," -br %s000", argv[++i]); 
				continue;
			}
		}
	}
	
	if(exeName1 == "neroAacEnc.exe")
	{
		 p+=sprintf(p, " -ignorelength -if - -of \"%s\"", sOutFileName);
	}
	else if((exeName1 == "faac.exe") || (exeName1 == "flake.exe"))
	{
		p+=sprintf(p," - -o \"%s\"", sOutFileName);
	}
	else
	{
		p+=sprintf(p," - \"%s\"", sOutFileName);
	}
	char exeName[MAX_PATH];
	memset(exeName,0,sizeof(exeName));
	{
		char exeName2[MAX_PATH];
		memset(exeName2,0,sizeof(exeName2));
		bool HasPath=false;
		for(char * p = exeName1;(*p)!=NULL;p++)
		{
			if(*p=='\\')
			{
				HasPath=true;
				break;
			}
		}
		if(HasPath)
		{
			sprintf(exeName2,"%s",exeName1);
		}
		else
		{
			char buf[MAX_PATH];
			GetModuleFileName(NULL, buf, MAX_PATH-1);
			char drive[MAX_PATH];
			char dir[MAX_PATH];
			char fname[MAX_PATH];
			char ext[MAX_PATH];
			_splitpath( buf, drive, dir, fname, ext );
			sprintf(exeName2,"%s%s%s",drive,dir, exeName1);
		}
		GetShortPathName(exeName2,exeName, sizeof(exeName));
	}


	char argumentLineToRun[4096];
	memset(argumentLineToRun,0,sizeof(argumentLineToRun));

	strcat(argumentLineToRun, exeName);
	strcat(argumentLineToRun, " ");
	strcat(argumentLineToRun, argumentLine);

	// Argument line is ready

	///////////////////////////////////////////////////////////////////////////
	// Prepare for pipelining :)
	SECURITY_ATTRIBUTES saAttr; 
	memset(&saAttr, 0, sizeof(saAttr));
	// Set the bInheritHandle flag so pipe handles are inherited. 
	saAttr.nLength = sizeof(SECURITY_ATTRIBUTES); 
	saAttr.bInheritHandle = TRUE; 
	saAttr.lpSecurityDescriptor = NULL;

	HANDLE	hChildStdinRd, 
			hChildStdinWr; 

	// Create a pipe for the child process's STDIN. 
	if (! CreatePipe(&hChildStdinRd, &hChildStdinWr, &saAttr, 0)) 
		return -1;
	// Duplicate the write handle to the pipe so it is not inherited. 
	if (! DuplicateHandle(GetCurrentProcess(), hChildStdinWr, 
		GetCurrentProcess(), &g_hStream, 0, 
		FALSE,                  // not inherited 
		DUPLICATE_SAME_ACCESS))	return -1; 
	CloseHandle(hChildStdinWr); 

	STARTUPINFO  StartupInfo;

	memset(&StartupInfo, 0, sizeof(StartupInfo));
	memset(&g_ProcessInformation, 0, sizeof(g_ProcessInformation));

	StartupInfo.cb= sizeof(StartupInfo);
	StartupInfo.dwFlags = STARTF_USESTDHANDLES;
	StartupInfo.hStdError = GetStdHandle(STD_ERROR_HANDLE);
	StartupInfo.hStdOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	StartupInfo.hStdInput = hChildStdinRd;

	///////////////////////////////////////////////////////////////////////////
 	// let's start FAAC.EXE ;)
	int nResult =CreateProcess( 
		exeName,
		argumentLineToRun,
		NULL,
		NULL,
		true,
		NULL,
		NULL,
		NULL,
		&StartupInfo,
		&g_ProcessInformation);
	int nError=0;
	if(nResult==0)
		nError = GetLastError();
	return nResult==0?-nError:0;
			
	return 0;
}


typedef struct wavHeader {
  unsigned int chunkid;
  unsigned int totdatasize;
  unsigned int rifftype;
  unsigned int fmt;
  int fmtsize;
  unsigned short ccode;
  short nch;
  int srate;
  int bytespersec;
  short blockalign;
  short bps;
  unsigned int data;
  unsigned int datasize;
} wavHeader;

int Init(
		 int nSampleRate,
		 int nChannelsCount,
		 int nBitsPerSample,
		 char * sOutFileName,
		 char** argv,int argc,
		 char * sDescription,
		 char * err)
{

	int r = Init222(nSampleRate, nChannelsCount, nBitsPerSample, sOutFileName, argv, argc, sDescription, err);
	if(r!=0) return r;
	//Let's write WAV header
	wavHeader hdr;
	memset(&hdr,0,sizeof(hdr));
	memcpy(&hdr.chunkid, "RIFF", sizeof(hdr.chunkid));
	hdr.totdatasize = 0xFFFFFF00;
	memcpy(&hdr.rifftype, "WAVE", sizeof(hdr.rifftype));
	memcpy(&hdr.fmt, "fmt ", sizeof(hdr.fmt));
	hdr.fmtsize=0x10;
	hdr.ccode=1;
	hdr.nch = nChannelsCount;
	hdr.srate = nSampleRate;
	hdr.bytespersec=nChannelsCount*nSampleRate*nBitsPerSample/8;
	hdr.blockalign=nChannelsCount*nBitsPerSample/8;
	hdr.bps = nBitsPerSample;
	hdr.datasize = hdr.totdatasize - 36;
	memcpy(&hdr.data, "data", sizeof(hdr.data));

	return Encode((unsigned char*)(&hdr), sizeof(hdr), err);

}

int Encode(
		 unsigned char * aRawPCM,
		 size_t nSize,
		 char * err
		 )
{
	DWORD dwWritten=0;
	if(0 == GetExitCodeProcess(g_ProcessInformation.hProcess, &dwWritten)) return -1;
	if (STILL_ACTIVE!=dwWritten)
	{
		sprintf(err, "neroAacEnc.exe was terminated!");
		return -1;
	}
	// Write pBuf contents to a pipe. 
	if (! WriteFile(g_hStream, aRawPCM, nSize, &dwWritten, NULL)) return -1; 
	if (dwWritten!=nSize) return -1;
	int nWaitResult = WaitForInputIdle(g_ProcessInformation.hProcess,INFINITE);
//	if(WAIT_FAILED==nWaitResult) return -1;
	return 0;
}

int Done(char* err)
{
	// Close the pipe handle so the child process stops reading. 
	CloseHandle(g_hStream);
	CloseHandle( g_ProcessInformation.hThread );
	DWORD dwWritten=0;
	GetExitCodeProcess(g_ProcessInformation.hProcess, &dwWritten);
	if (STILL_ACTIVE==dwWritten) WaitForSingleObject( g_ProcessInformation.hProcess, INFINITE );
	CloseHandle( g_ProcessInformation.hProcess );
	return 0;
}

